using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace RadarrSharp.Models {

  /// <summary>
  /// 
  /// </summary>
  [DataContract]
  public class Blocklist {
    /// <summary>
    /// Gets or Sets MovieId
    /// </summary>
    [DataMember(Name="movieId", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "movieId")]
    public decimal? MovieId { get; set; }

    /// <summary>
    /// Gets or Sets SourceTitle
    /// </summary>
    [DataMember(Name="sourceTitle", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "sourceTitle")]
    public string SourceTitle { get; set; }

    /// <summary>
    /// Gets or Sets Languages
    /// </summary>
    [DataMember(Name="languages", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "languages")]
    public List<HistoryLanguages> Languages { get; set; }

    /// <summary>
    /// Gets or Sets Quality
    /// </summary>
    [DataMember(Name="quality", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "quality")]
    public Quality Quality { get; set; }

    /// <summary>
    /// Gets or Sets CustomFormats
    /// </summary>
    [DataMember(Name="customFormats", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "customFormats")]
    public List<CustomFormat> CustomFormats { get; set; }

    /// <summary>
    /// Gets or Sets Date
    /// </summary>
    [DataMember(Name="date", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "date")]
    public string Date { get; set; }

    /// <summary>
    /// Gets or Sets Protocol
    /// </summary>
    [DataMember(Name="protocol", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "protocol")]
    public string Protocol { get; set; }

    /// <summary>
    /// Gets or Sets Indexer
    /// </summary>
    [DataMember(Name="indexer", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "indexer")]
    public string Indexer { get; set; }

    /// <summary>
    /// Gets or Sets Message
    /// </summary>
    [DataMember(Name="message", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "message")]
    public string Message { get; set; }

    /// <summary>
    /// Gets or Sets Id
    /// </summary>
    [DataMember(Name="id", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "id")]
    public decimal? Id { get; set; }


    /// <summary>
    /// Get the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()  {
      var sb = new StringBuilder();
      sb.Append("class Blocklist {\n");
      sb.Append("  MovieId: ").Append(MovieId).Append("\n");
      sb.Append("  SourceTitle: ").Append(SourceTitle).Append("\n");
      sb.Append("  Languages: ").Append(Languages).Append("\n");
      sb.Append("  Quality: ").Append(Quality).Append("\n");
      sb.Append("  CustomFormats: ").Append(CustomFormats).Append("\n");
      sb.Append("  Date: ").Append(Date).Append("\n");
      sb.Append("  Protocol: ").Append(Protocol).Append("\n");
      sb.Append("  Indexer: ").Append(Indexer).Append("\n");
      sb.Append("  Message: ").Append(Message).Append("\n");
      sb.Append("  Id: ").Append(Id).Append("\n");
      sb.Append("}\n");
      return sb.ToString();
    }

    /// <summary>
    /// Get the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson() {
      return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

}
}
