using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace RadarrSharp.Models {

  /// <summary>
  /// 
  /// </summary>
  [DataContract]
  public class ConfigUiBody {
    /// <summary>
    /// Gets or Sets FirstDayOfWeek
    /// </summary>
    [DataMember(Name="firstDayOfWeek", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "firstDayOfWeek")]
    public int? FirstDayOfWeek { get; set; }

    /// <summary>
    /// Gets or Sets CalendarWeekColumnHeader
    /// </summary>
    [DataMember(Name="calendarWeekColumnHeader", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "calendarWeekColumnHeader")]
    public string CalendarWeekColumnHeader { get; set; }

    /// <summary>
    /// Gets or Sets MovieRuntimeFormat
    /// </summary>
    [DataMember(Name="movieRuntimeFormat", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "movieRuntimeFormat")]
    public string MovieRuntimeFormat { get; set; }

    /// <summary>
    /// Gets or Sets ShortDateFormat
    /// </summary>
    [DataMember(Name="shortDateFormat", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "shortDateFormat")]
    public string ShortDateFormat { get; set; }

    /// <summary>
    /// Gets or Sets LongDateFormat
    /// </summary>
    [DataMember(Name="longDateFormat", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "longDateFormat")]
    public string LongDateFormat { get; set; }

    /// <summary>
    /// Gets or Sets TimeFormat
    /// </summary>
    [DataMember(Name="timeFormat", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "timeFormat")]
    public string TimeFormat { get; set; }

    /// <summary>
    /// Gets or Sets ShowRelativeDates
    /// </summary>
    [DataMember(Name="showRelativeDates", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "showRelativeDates")]
    public bool? ShowRelativeDates { get; set; }

    /// <summary>
    /// Gets or Sets EnableColorImpairedMode
    /// </summary>
    [DataMember(Name="enableColorImpairedMode", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "enableColorImpairedMode")]
    public bool? EnableColorImpairedMode { get; set; }

    /// <summary>
    /// Gets or Sets MovieInfoLanguage
    /// </summary>
    [DataMember(Name="movieInfoLanguage", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "movieInfoLanguage")]
    public decimal? MovieInfoLanguage { get; set; }

    /// <summary>
    /// Gets or Sets Id
    /// </summary>
    [DataMember(Name="id", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "id")]
    public int? Id { get; set; }


    /// <summary>
    /// Get the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()  {
      var sb = new StringBuilder();
      sb.Append("class ConfigUiBody {\n");
      sb.Append("  FirstDayOfWeek: ").Append(FirstDayOfWeek).Append("\n");
      sb.Append("  CalendarWeekColumnHeader: ").Append(CalendarWeekColumnHeader).Append("\n");
      sb.Append("  MovieRuntimeFormat: ").Append(MovieRuntimeFormat).Append("\n");
      sb.Append("  ShortDateFormat: ").Append(ShortDateFormat).Append("\n");
      sb.Append("  LongDateFormat: ").Append(LongDateFormat).Append("\n");
      sb.Append("  TimeFormat: ").Append(TimeFormat).Append("\n");
      sb.Append("  ShowRelativeDates: ").Append(ShowRelativeDates).Append("\n");
      sb.Append("  EnableColorImpairedMode: ").Append(EnableColorImpairedMode).Append("\n");
      sb.Append("  MovieInfoLanguage: ").Append(MovieInfoLanguage).Append("\n");
      sb.Append("  Id: ").Append(Id).Append("\n");
      sb.Append("}\n");
      return sb.ToString();
    }

    /// <summary>
    /// Get the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson() {
      return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

}
}
