using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace RadarrSharp.Models {

  /// <summary>
  /// 
  /// </summary>
  [DataContract]
  public class Image {
    /// <summary>
    /// Gets or Sets CoverType
    /// </summary>
    [DataMember(Name="coverType", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "coverType")]
    public string CoverType { get; set; }

    /// <summary>
    /// Gets or Sets Url
    /// </summary>
    [DataMember(Name="url", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "url")]
    public string Url { get; set; }

    /// <summary>
    /// Gets or Sets RemoteUrl
    /// </summary>
    [DataMember(Name="remoteUrl", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "remoteUrl")]
    public string RemoteUrl { get; set; }


    /// <summary>
    /// Get the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()  {
      var sb = new StringBuilder();
      sb.Append("class Image {\n");
      sb.Append("  CoverType: ").Append(CoverType).Append("\n");
      sb.Append("  Url: ").Append(Url).Append("\n");
      sb.Append("  RemoteUrl: ").Append(RemoteUrl).Append("\n");
      sb.Append("}\n");
      return sb.ToString();
    }

    /// <summary>
    /// Get the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson() {
      return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

}
}
