using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace RadarrSharp.Models {

  /// <summary>
  /// 
  /// </summary>
  [DataContract]
  public class ImportList {
    /// <summary>
    /// Gets or Sets Enabled
    /// </summary>
    [DataMember(Name="enabled", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "enabled")]
    public bool? Enabled { get; set; }

    /// <summary>
    /// Gets or Sets EnableAuto
    /// </summary>
    [DataMember(Name="enableAuto", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "enableAuto")]
    public bool? EnableAuto { get; set; }

    /// <summary>
    /// Gets or Sets ShouldMonitor
    /// </summary>
    [DataMember(Name="shouldMonitor", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "shouldMonitor")]
    public bool? ShouldMonitor { get; set; }

    /// <summary>
    /// Gets or Sets RootFolderPath
    /// </summary>
    [DataMember(Name="rootFolderPath", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "rootFolderPath")]
    public string RootFolderPath { get; set; }

    /// <summary>
    /// Gets or Sets QualityProfileId
    /// </summary>
    [DataMember(Name="qualityProfileId", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "qualityProfileId")]
    public decimal? QualityProfileId { get; set; }

    /// <summary>
    /// Gets or Sets SearchOnAdd
    /// </summary>
    [DataMember(Name="searchOnAdd", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "searchOnAdd")]
    public bool? SearchOnAdd { get; set; }

    /// <summary>
    /// Gets or Sets MinimumAvailability
    /// </summary>
    [DataMember(Name="minimumAvailability", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "minimumAvailability")]
    public string MinimumAvailability { get; set; }

    /// <summary>
    /// Gets or Sets ListType
    /// </summary>
    [DataMember(Name="listType", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "listType")]
    public string ListType { get; set; }

    /// <summary>
    /// Gets or Sets ListOrder
    /// </summary>
    [DataMember(Name="listOrder", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "listOrder")]
    public decimal? ListOrder { get; set; }

    /// <summary>
    /// Gets or Sets Name
    /// </summary>
    [DataMember(Name="name", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "name")]
    public string Name { get; set; }

    /// <summary>
    /// Gets or Sets Fields
    /// </summary>
    [DataMember(Name="fields", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "fields")]
    public List<ProviderField> Fields { get; set; }

    /// <summary>
    /// Gets or Sets ImplementationName
    /// </summary>
    [DataMember(Name="implementationName", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "implementationName")]
    public string ImplementationName { get; set; }

    /// <summary>
    /// Gets or Sets Implementation
    /// </summary>
    [DataMember(Name="implementation", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "implementation")]
    public string Implementation { get; set; }

    /// <summary>
    /// Gets or Sets ConfigContract
    /// </summary>
    [DataMember(Name="configContract", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "configContract")]
    public string ConfigContract { get; set; }

    /// <summary>
    /// Gets or Sets InfoLink
    /// </summary>
    [DataMember(Name="infoLink", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "infoLink")]
    public string InfoLink { get; set; }

    /// <summary>
    /// Gets or Sets Tags
    /// </summary>
    [DataMember(Name="tags", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "tags")]
    public List<int?> Tags { get; set; }

    /// <summary>
    /// Gets or Sets Id
    /// </summary>
    [DataMember(Name="id", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "id")]
    public int? Id { get; set; }


    /// <summary>
    /// Get the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()  {
      var sb = new StringBuilder();
      sb.Append("class ImportList {\n");
      sb.Append("  Enabled: ").Append(Enabled).Append("\n");
      sb.Append("  EnableAuto: ").Append(EnableAuto).Append("\n");
      sb.Append("  ShouldMonitor: ").Append(ShouldMonitor).Append("\n");
      sb.Append("  RootFolderPath: ").Append(RootFolderPath).Append("\n");
      sb.Append("  QualityProfileId: ").Append(QualityProfileId).Append("\n");
      sb.Append("  SearchOnAdd: ").Append(SearchOnAdd).Append("\n");
      sb.Append("  MinimumAvailability: ").Append(MinimumAvailability).Append("\n");
      sb.Append("  ListType: ").Append(ListType).Append("\n");
      sb.Append("  ListOrder: ").Append(ListOrder).Append("\n");
      sb.Append("  Name: ").Append(Name).Append("\n");
      sb.Append("  Fields: ").Append(Fields).Append("\n");
      sb.Append("  ImplementationName: ").Append(ImplementationName).Append("\n");
      sb.Append("  Implementation: ").Append(Implementation).Append("\n");
      sb.Append("  ConfigContract: ").Append(ConfigContract).Append("\n");
      sb.Append("  InfoLink: ").Append(InfoLink).Append("\n");
      sb.Append("  Tags: ").Append(Tags).Append("\n");
      sb.Append("  Id: ").Append(Id).Append("\n");
      sb.Append("}\n");
      return sb.ToString();
    }

    /// <summary>
    /// Get the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson() {
      return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

}
}
