using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace RadarrSharp.Models {

  /// <summary>
  /// 
  /// </summary>
  [DataContract]
  public class Indexer {
    /// <summary>
    /// Gets or Sets EnableRss
    /// </summary>
    [DataMember(Name="enableRss", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "enableRss")]
    public bool? EnableRss { get; set; }

    /// <summary>
    /// Gets or Sets EnableAutomaticSearch
    /// </summary>
    [DataMember(Name="enableAutomaticSearch", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "enableAutomaticSearch")]
    public bool? EnableAutomaticSearch { get; set; }

    /// <summary>
    /// Gets or Sets EnableInteractiveSearch
    /// </summary>
    [DataMember(Name="enableInteractiveSearch", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "enableInteractiveSearch")]
    public bool? EnableInteractiveSearch { get; set; }

    /// <summary>
    /// Gets or Sets SupportsRss
    /// </summary>
    [DataMember(Name="supportsRss", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "supportsRss")]
    public bool? SupportsRss { get; set; }

    /// <summary>
    /// Gets or Sets SupportsSearch
    /// </summary>
    [DataMember(Name="supportsSearch", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "supportsSearch")]
    public bool? SupportsSearch { get; set; }

    /// <summary>
    /// Gets or Sets Protocol
    /// </summary>
    [DataMember(Name="protocol", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "protocol")]
    public string Protocol { get; set; }

    /// <summary>
    /// Gets or Sets Priority
    /// </summary>
    [DataMember(Name="priority", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "priority")]
    public int? Priority { get; set; }

    /// <summary>
    /// Gets or Sets Name
    /// </summary>
    [DataMember(Name="name", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "name")]
    public string Name { get; set; }

    /// <summary>
    /// Gets or Sets Fields
    /// </summary>
    [DataMember(Name="fields", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "fields")]
    public List<ProviderField> Fields { get; set; }

    /// <summary>
    /// Gets or Sets ImplementationName
    /// </summary>
    [DataMember(Name="implementationName", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "implementationName")]
    public string ImplementationName { get; set; }

    /// <summary>
    /// Gets or Sets Implementation
    /// </summary>
    [DataMember(Name="implementation", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "implementation")]
    public string Implementation { get; set; }

    /// <summary>
    /// Gets or Sets ConfigContract
    /// </summary>
    [DataMember(Name="configContract", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "configContract")]
    public string ConfigContract { get; set; }

    /// <summary>
    /// Gets or Sets InfoLink
    /// </summary>
    [DataMember(Name="infoLink", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "infoLink")]
    public string InfoLink { get; set; }

    /// <summary>
    /// Gets or Sets Tags
    /// </summary>
    [DataMember(Name="tags", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "tags")]
    public List<Object> Tags { get; set; }

    /// <summary>
    /// Gets or Sets Id
    /// </summary>
    [DataMember(Name="id", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "id")]
    public decimal? Id { get; set; }


    /// <summary>
    /// Get the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()  {
      var sb = new StringBuilder();
      sb.Append("class Indexer {\n");
      sb.Append("  EnableRss: ").Append(EnableRss).Append("\n");
      sb.Append("  EnableAutomaticSearch: ").Append(EnableAutomaticSearch).Append("\n");
      sb.Append("  EnableInteractiveSearch: ").Append(EnableInteractiveSearch).Append("\n");
      sb.Append("  SupportsRss: ").Append(SupportsRss).Append("\n");
      sb.Append("  SupportsSearch: ").Append(SupportsSearch).Append("\n");
      sb.Append("  Protocol: ").Append(Protocol).Append("\n");
      sb.Append("  Priority: ").Append(Priority).Append("\n");
      sb.Append("  Name: ").Append(Name).Append("\n");
      sb.Append("  Fields: ").Append(Fields).Append("\n");
      sb.Append("  ImplementationName: ").Append(ImplementationName).Append("\n");
      sb.Append("  Implementation: ").Append(Implementation).Append("\n");
      sb.Append("  ConfigContract: ").Append(ConfigContract).Append("\n");
      sb.Append("  InfoLink: ").Append(InfoLink).Append("\n");
      sb.Append("  Tags: ").Append(Tags).Append("\n");
      sb.Append("  Id: ").Append(Id).Append("\n");
      sb.Append("}\n");
      return sb.ToString();
    }

    /// <summary>
    /// Get the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson() {
      return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

}
}
