using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace RadarrSharp.Models {

  /// <summary>
  /// 
  /// </summary>
  [DataContract]
  public class InlineResponse2009 {
    /// <summary>
    /// Gets or Sets Languages
    /// </summary>
    [DataMember(Name="languages", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "languages")]
    public List<QueuedetailsLanguages> Languages { get; set; }

    /// <summary>
    /// Gets or Sets Quality
    /// </summary>
    [DataMember(Name="quality", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "quality")]
    public Quality Quality { get; set; }

    /// <summary>
    /// Gets or Sets CustomFormats
    /// </summary>
    [DataMember(Name="customFormats", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "customFormats")]
    public List<CustomFormat> CustomFormats { get; set; }

    /// <summary>
    /// Gets or Sets Size
    /// </summary>
    [DataMember(Name="size", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "size")]
    public decimal? Size { get; set; }

    /// <summary>
    /// Gets or Sets Title
    /// </summary>
    [DataMember(Name="title", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "title")]
    public string Title { get; set; }

    /// <summary>
    /// Gets or Sets Sizeleft
    /// </summary>
    [DataMember(Name="sizeleft", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "sizeleft")]
    public decimal? Sizeleft { get; set; }

    /// <summary>
    /// Gets or Sets Timeleft
    /// </summary>
    [DataMember(Name="timeleft", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "timeleft")]
    public string Timeleft { get; set; }

    /// <summary>
    /// Gets or Sets EstimatedCompletionTime
    /// </summary>
    [DataMember(Name="estimatedCompletionTime", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "estimatedCompletionTime")]
    public string EstimatedCompletionTime { get; set; }

    /// <summary>
    /// Gets or Sets Status
    /// </summary>
    [DataMember(Name="status", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "status")]
    public string Status { get; set; }

    /// <summary>
    /// Gets or Sets TrackedDownloadStatus
    /// </summary>
    [DataMember(Name="trackedDownloadStatus", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "trackedDownloadStatus")]
    public string TrackedDownloadStatus { get; set; }

    /// <summary>
    /// Gets or Sets TrackedDownloadState
    /// </summary>
    [DataMember(Name="trackedDownloadState", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "trackedDownloadState")]
    public string TrackedDownloadState { get; set; }

    /// <summary>
    /// Gets or Sets StatusMessages
    /// </summary>
    [DataMember(Name="statusMessages", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "statusMessages")]
    public List<QueuedetailsStatusMessages> StatusMessages { get; set; }

    /// <summary>
    /// Gets or Sets ErrorMessage
    /// </summary>
    [DataMember(Name="errorMessage", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "errorMessage")]
    public string ErrorMessage { get; set; }

    /// <summary>
    /// Gets or Sets DownloadId
    /// </summary>
    [DataMember(Name="downloadId", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "downloadId")]
    public string DownloadId { get; set; }

    /// <summary>
    /// Gets or Sets Protocol
    /// </summary>
    [DataMember(Name="protocol", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "protocol")]
    public string Protocol { get; set; }

    /// <summary>
    /// Gets or Sets DownloadClient
    /// </summary>
    [DataMember(Name="downloadClient", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "downloadClient")]
    public string DownloadClient { get; set; }

    /// <summary>
    /// Gets or Sets Indexer
    /// </summary>
    [DataMember(Name="indexer", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "indexer")]
    public string Indexer { get; set; }

    /// <summary>
    /// Gets or Sets OutputPath
    /// </summary>
    [DataMember(Name="outputPath", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "outputPath")]
    public string OutputPath { get; set; }

    /// <summary>
    /// Gets or Sets Id
    /// </summary>
    [DataMember(Name="id", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "id")]
    public int? Id { get; set; }


    /// <summary>
    /// Get the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()  {
      var sb = new StringBuilder();
      sb.Append("class InlineResponse2009 {\n");
      sb.Append("  Languages: ").Append(Languages).Append("\n");
      sb.Append("  Quality: ").Append(Quality).Append("\n");
      sb.Append("  CustomFormats: ").Append(CustomFormats).Append("\n");
      sb.Append("  Size: ").Append(Size).Append("\n");
      sb.Append("  Title: ").Append(Title).Append("\n");
      sb.Append("  Sizeleft: ").Append(Sizeleft).Append("\n");
      sb.Append("  Timeleft: ").Append(Timeleft).Append("\n");
      sb.Append("  EstimatedCompletionTime: ").Append(EstimatedCompletionTime).Append("\n");
      sb.Append("  Status: ").Append(Status).Append("\n");
      sb.Append("  TrackedDownloadStatus: ").Append(TrackedDownloadStatus).Append("\n");
      sb.Append("  TrackedDownloadState: ").Append(TrackedDownloadState).Append("\n");
      sb.Append("  StatusMessages: ").Append(StatusMessages).Append("\n");
      sb.Append("  ErrorMessage: ").Append(ErrorMessage).Append("\n");
      sb.Append("  DownloadId: ").Append(DownloadId).Append("\n");
      sb.Append("  Protocol: ").Append(Protocol).Append("\n");
      sb.Append("  DownloadClient: ").Append(DownloadClient).Append("\n");
      sb.Append("  Indexer: ").Append(Indexer).Append("\n");
      sb.Append("  OutputPath: ").Append(OutputPath).Append("\n");
      sb.Append("  Id: ").Append(Id).Append("\n");
      sb.Append("}\n");
      return sb.ToString();
    }

    /// <summary>
    /// Get the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson() {
      return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

}
}
