using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace RadarrSharp.Models {

  /// <summary>
  /// 
  /// </summary>
  [DataContract]
  public class Metadata {
    /// <summary>
    /// Gets or Sets Enable
    /// </summary>
    [DataMember(Name="enable", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "enable")]
    public bool? Enable { get; set; }

    /// <summary>
    /// Gets or Sets Name
    /// </summary>
    [DataMember(Name="name", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "name")]
    public string Name { get; set; }

    /// <summary>
    /// Gets or Sets Fields
    /// </summary>
    [DataMember(Name="fields", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "fields")]
    public List<ProviderField> Fields { get; set; }

    /// <summary>
    /// Gets or Sets ImplementationName
    /// </summary>
    [DataMember(Name="implementationName", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "implementationName")]
    public string ImplementationName { get; set; }

    /// <summary>
    /// Gets or Sets Implementation
    /// </summary>
    [DataMember(Name="implementation", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "implementation")]
    public string Implementation { get; set; }

    /// <summary>
    /// Gets or Sets ConfigContract
    /// </summary>
    [DataMember(Name="configContract", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "configContract")]
    public string ConfigContract { get; set; }

    /// <summary>
    /// Gets or Sets InfoLink
    /// </summary>
    [DataMember(Name="infoLink", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "infoLink")]
    public string InfoLink { get; set; }

    /// <summary>
    /// Gets or Sets Tags
    /// </summary>
    [DataMember(Name="tags", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "tags")]
    public List<int?> Tags { get; set; }

    /// <summary>
    /// Gets or Sets Id
    /// </summary>
    [DataMember(Name="id", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "id")]
    public int? Id { get; set; }


    /// <summary>
    /// Get the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()  {
      var sb = new StringBuilder();
      sb.Append("class Metadata {\n");
      sb.Append("  Enable: ").Append(Enable).Append("\n");
      sb.Append("  Name: ").Append(Name).Append("\n");
      sb.Append("  Fields: ").Append(Fields).Append("\n");
      sb.Append("  ImplementationName: ").Append(ImplementationName).Append("\n");
      sb.Append("  Implementation: ").Append(Implementation).Append("\n");
      sb.Append("  ConfigContract: ").Append(ConfigContract).Append("\n");
      sb.Append("  InfoLink: ").Append(InfoLink).Append("\n");
      sb.Append("  Tags: ").Append(Tags).Append("\n");
      sb.Append("  Id: ").Append(Id).Append("\n");
      sb.Append("}\n");
      return sb.ToString();
    }

    /// <summary>
    /// Get the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson() {
      return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

}
}
