using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace RadarrSharp.Models {

  /// <summary>
  /// 
  /// </summary>
  [DataContract]
  public class MovieEditorBody {
    /// <summary>
    /// Gets or Sets MovieIds
    /// </summary>
    [DataMember(Name="movieIds", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "movieIds")]
    public List<int?> MovieIds { get; set; }

    /// <summary>
    /// Gets or Sets Monitored
    /// </summary>
    [DataMember(Name="monitored", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "monitored")]
    public bool? Monitored { get; set; }

    /// <summary>
    /// Gets or Sets QualityProfileId
    /// </summary>
    [DataMember(Name="qualityProfileId", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "qualityProfileId")]
    public int? QualityProfileId { get; set; }

    /// <summary>
    /// Gets or Sets MinimumAvailability
    /// </summary>
    [DataMember(Name="minimumAvailability", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "minimumAvailability")]
    public string MinimumAvailability { get; set; }

    /// <summary>
    /// Gets or Sets RootFolderPath
    /// </summary>
    [DataMember(Name="rootFolderPath", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "rootFolderPath")]
    public string RootFolderPath { get; set; }

    /// <summary>
    /// Gets or Sets Tags
    /// </summary>
    [DataMember(Name="tags", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "tags")]
    public List<int?> Tags { get; set; }

    /// <summary>
    /// Gets or Sets ApplyTags
    /// </summary>
    [DataMember(Name="applyTags", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "applyTags")]
    public string ApplyTags { get; set; }

    /// <summary>
    /// Gets or Sets MoveFiles
    /// </summary>
    [DataMember(Name="moveFiles", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "moveFiles")]
    public bool? MoveFiles { get; set; }


    /// <summary>
    /// Get the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()  {
      var sb = new StringBuilder();
      sb.Append("class MovieEditorBody {\n");
      sb.Append("  MovieIds: ").Append(MovieIds).Append("\n");
      sb.Append("  Monitored: ").Append(Monitored).Append("\n");
      sb.Append("  QualityProfileId: ").Append(QualityProfileId).Append("\n");
      sb.Append("  MinimumAvailability: ").Append(MinimumAvailability).Append("\n");
      sb.Append("  RootFolderPath: ").Append(RootFolderPath).Append("\n");
      sb.Append("  Tags: ").Append(Tags).Append("\n");
      sb.Append("  ApplyTags: ").Append(ApplyTags).Append("\n");
      sb.Append("  MoveFiles: ").Append(MoveFiles).Append("\n");
      sb.Append("}\n");
      return sb.ToString();
    }

    /// <summary>
    /// Get the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson() {
      return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

}
}
