using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace RadarrSharp.Models {

  /// <summary>
  /// 
  /// </summary>
  [DataContract]
  public class MovieFile {
    /// <summary>
    /// Gets or Sets MovieId
    /// </summary>
    [DataMember(Name="movieId", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "movieId")]
    public int? MovieId { get; set; }

    /// <summary>
    /// Gets or Sets RelativePath
    /// </summary>
    [DataMember(Name="relativePath", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "relativePath")]
    public string RelativePath { get; set; }

    /// <summary>
    /// Gets or Sets Path
    /// </summary>
    [DataMember(Name="path", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "path")]
    public string Path { get; set; }

    /// <summary>
    /// Gets or Sets Size
    /// </summary>
    [DataMember(Name="size", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "size")]
    public decimal? Size { get; set; }

    /// <summary>
    /// Gets or Sets DateAdded
    /// </summary>
    [DataMember(Name="dateAdded", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "dateAdded")]
    public string DateAdded { get; set; }

    /// <summary>
    /// Gets or Sets IndexerFlags
    /// </summary>
    [DataMember(Name="indexerFlags", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "indexerFlags")]
    public int? IndexerFlags { get; set; }

    /// <summary>
    /// Gets or Sets Quality
    /// </summary>
    [DataMember(Name="quality", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "quality")]
    public Quality Quality { get; set; }

    /// <summary>
    /// Gets or Sets MediaInfo
    /// </summary>
    [DataMember(Name="mediaInfo", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "mediaInfo")]
    public MovieFileMediaInfo MediaInfo { get; set; }

    /// <summary>
    /// Gets or Sets QualityCutoffNotMet
    /// </summary>
    [DataMember(Name="qualityCutoffNotMet", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "qualityCutoffNotMet")]
    public bool? QualityCutoffNotMet { get; set; }

    /// <summary>
    /// Gets or Sets Languages
    /// </summary>
    [DataMember(Name="languages", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "languages")]
    public List<HistoryLanguages> Languages { get; set; }

    /// <summary>
    /// Gets or Sets ReleaseGroup
    /// </summary>
    [DataMember(Name="releaseGroup", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "releaseGroup")]
    public string ReleaseGroup { get; set; }

    /// <summary>
    /// Gets or Sets Id
    /// </summary>
    [DataMember(Name="id", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "id")]
    public int? Id { get; set; }


    /// <summary>
    /// Get the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()  {
      var sb = new StringBuilder();
      sb.Append("class MovieFile {\n");
      sb.Append("  MovieId: ").Append(MovieId).Append("\n");
      sb.Append("  RelativePath: ").Append(RelativePath).Append("\n");
      sb.Append("  Path: ").Append(Path).Append("\n");
      sb.Append("  Size: ").Append(Size).Append("\n");
      sb.Append("  DateAdded: ").Append(DateAdded).Append("\n");
      sb.Append("  IndexerFlags: ").Append(IndexerFlags).Append("\n");
      sb.Append("  Quality: ").Append(Quality).Append("\n");
      sb.Append("  MediaInfo: ").Append(MediaInfo).Append("\n");
      sb.Append("  QualityCutoffNotMet: ").Append(QualityCutoffNotMet).Append("\n");
      sb.Append("  Languages: ").Append(Languages).Append("\n");
      sb.Append("  ReleaseGroup: ").Append(ReleaseGroup).Append("\n");
      sb.Append("  Id: ").Append(Id).Append("\n");
      sb.Append("}\n");
      return sb.ToString();
    }

    /// <summary>
    /// Get the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson() {
      return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

}
}
