using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace RadarrSharp.Models {

  /// <summary>
  /// 
  /// </summary>
  [DataContract]
  public class MovieFileMediaInfo {
    /// <summary>
    /// Gets or Sets AudioAdditionalFeatures
    /// </summary>
    [DataMember(Name="audioAdditionalFeatures", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "audioAdditionalFeatures")]
    public string AudioAdditionalFeatures { get; set; }

    /// <summary>
    /// Gets or Sets AudioBitrate
    /// </summary>
    [DataMember(Name="audioBitrate", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "audioBitrate")]
    public decimal? AudioBitrate { get; set; }

    /// <summary>
    /// Gets or Sets AudioChannels
    /// </summary>
    [DataMember(Name="audioChannels", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "audioChannels")]
    public decimal? AudioChannels { get; set; }

    /// <summary>
    /// Gets or Sets AudioCodec
    /// </summary>
    [DataMember(Name="audioCodec", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "audioCodec")]
    public string AudioCodec { get; set; }

    /// <summary>
    /// Gets or Sets AudioLanguages
    /// </summary>
    [DataMember(Name="audioLanguages", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "audioLanguages")]
    public string AudioLanguages { get; set; }

    /// <summary>
    /// Gets or Sets AudioStreamCount
    /// </summary>
    [DataMember(Name="audioStreamCount", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "audioStreamCount")]
    public decimal? AudioStreamCount { get; set; }

    /// <summary>
    /// Gets or Sets VideoBitDepth
    /// </summary>
    [DataMember(Name="videoBitDepth", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "videoBitDepth")]
    public decimal? VideoBitDepth { get; set; }

    /// <summary>
    /// Gets or Sets VideoBitrate
    /// </summary>
    [DataMember(Name="videoBitrate", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "videoBitrate")]
    public decimal? VideoBitrate { get; set; }

    /// <summary>
    /// Gets or Sets VideoCodec
    /// </summary>
    [DataMember(Name="videoCodec", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "videoCodec")]
    public string VideoCodec { get; set; }

    /// <summary>
    /// Gets or Sets VideoFps
    /// </summary>
    [DataMember(Name="videoFps", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "videoFps")]
    public decimal? VideoFps { get; set; }

    /// <summary>
    /// Gets or Sets Resolution
    /// </summary>
    [DataMember(Name="resolution", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "resolution")]
    public string Resolution { get; set; }

    /// <summary>
    /// Gets or Sets RunTime
    /// </summary>
    [DataMember(Name="runTime", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "runTime")]
    public string RunTime { get; set; }

    /// <summary>
    /// Gets or Sets ScanType
    /// </summary>
    [DataMember(Name="scanType", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "scanType")]
    public string ScanType { get; set; }

    /// <summary>
    /// Gets or Sets Subtitles
    /// </summary>
    [DataMember(Name="subtitles", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "subtitles")]
    public string Subtitles { get; set; }


    /// <summary>
    /// Get the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()  {
      var sb = new StringBuilder();
      sb.Append("class MovieFileMediaInfo {\n");
      sb.Append("  AudioAdditionalFeatures: ").Append(AudioAdditionalFeatures).Append("\n");
      sb.Append("  AudioBitrate: ").Append(AudioBitrate).Append("\n");
      sb.Append("  AudioChannels: ").Append(AudioChannels).Append("\n");
      sb.Append("  AudioCodec: ").Append(AudioCodec).Append("\n");
      sb.Append("  AudioLanguages: ").Append(AudioLanguages).Append("\n");
      sb.Append("  AudioStreamCount: ").Append(AudioStreamCount).Append("\n");
      sb.Append("  VideoBitDepth: ").Append(VideoBitDepth).Append("\n");
      sb.Append("  VideoBitrate: ").Append(VideoBitrate).Append("\n");
      sb.Append("  VideoCodec: ").Append(VideoCodec).Append("\n");
      sb.Append("  VideoFps: ").Append(VideoFps).Append("\n");
      sb.Append("  Resolution: ").Append(Resolution).Append("\n");
      sb.Append("  RunTime: ").Append(RunTime).Append("\n");
      sb.Append("  ScanType: ").Append(ScanType).Append("\n");
      sb.Append("  Subtitles: ").Append(Subtitles).Append("\n");
      sb.Append("}\n");
      return sb.ToString();
    }

    /// <summary>
    /// Get the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson() {
      return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

}
}
