using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace RadarrSharp.Models {

  /// <summary>
  /// 
  /// </summary>
  [DataContract]
  public class Notification {
    /// <summary>
    /// Gets or Sets OnGrab
    /// </summary>
    [DataMember(Name="onGrab", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "onGrab")]
    public bool? OnGrab { get; set; }

    /// <summary>
    /// Gets or Sets OnDownload
    /// </summary>
    [DataMember(Name="onDownload", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "onDownload")]
    public bool? OnDownload { get; set; }

    /// <summary>
    /// Gets or Sets OnUpgrade
    /// </summary>
    [DataMember(Name="onUpgrade", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "onUpgrade")]
    public bool? OnUpgrade { get; set; }

    /// <summary>
    /// Gets or Sets OnRename
    /// </summary>
    [DataMember(Name="onRename", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "onRename")]
    public bool? OnRename { get; set; }

    /// <summary>
    /// Gets or Sets OnDelete
    /// </summary>
    [DataMember(Name="onDelete", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "onDelete")]
    public bool? OnDelete { get; set; }

    /// <summary>
    /// Gets or Sets OnHealthIssue
    /// </summary>
    [DataMember(Name="onHealthIssue", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "onHealthIssue")]
    public bool? OnHealthIssue { get; set; }

    /// <summary>
    /// Gets or Sets SupportsOnGrab
    /// </summary>
    [DataMember(Name="supportsOnGrab", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "supportsOnGrab")]
    public bool? SupportsOnGrab { get; set; }

    /// <summary>
    /// Gets or Sets SupportsOnDownload
    /// </summary>
    [DataMember(Name="supportsOnDownload", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "supportsOnDownload")]
    public bool? SupportsOnDownload { get; set; }

    /// <summary>
    /// Gets or Sets SupportsOnUpgrade
    /// </summary>
    [DataMember(Name="supportsOnUpgrade", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "supportsOnUpgrade")]
    public bool? SupportsOnUpgrade { get; set; }

    /// <summary>
    /// Gets or Sets SupportsOnRename
    /// </summary>
    [DataMember(Name="supportsOnRename", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "supportsOnRename")]
    public bool? SupportsOnRename { get; set; }

    /// <summary>
    /// Gets or Sets SupportsOnDelete
    /// </summary>
    [DataMember(Name="supportsOnDelete", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "supportsOnDelete")]
    public bool? SupportsOnDelete { get; set; }

    /// <summary>
    /// Gets or Sets SupportsOnHealthIssue
    /// </summary>
    [DataMember(Name="supportsOnHealthIssue", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "supportsOnHealthIssue")]
    public bool? SupportsOnHealthIssue { get; set; }

    /// <summary>
    /// Gets or Sets IncludeHealthWarnings
    /// </summary>
    [DataMember(Name="includeHealthWarnings", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "includeHealthWarnings")]
    public bool? IncludeHealthWarnings { get; set; }

    /// <summary>
    /// Gets or Sets Name
    /// </summary>
    [DataMember(Name="name", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "name")]
    public string Name { get; set; }

    /// <summary>
    /// Gets or Sets Fields
    /// </summary>
    [DataMember(Name="fields", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "fields")]
    public List<ProviderField> Fields { get; set; }

    /// <summary>
    /// Gets or Sets ImplementationName
    /// </summary>
    [DataMember(Name="implementationName", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "implementationName")]
    public string ImplementationName { get; set; }

    /// <summary>
    /// Gets or Sets Implementation
    /// </summary>
    [DataMember(Name="implementation", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "implementation")]
    public string Implementation { get; set; }

    /// <summary>
    /// Gets or Sets ConfigContract
    /// </summary>
    [DataMember(Name="configContract", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "configContract")]
    public string ConfigContract { get; set; }

    /// <summary>
    /// Gets or Sets InfoLink
    /// </summary>
    [DataMember(Name="infoLink", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "infoLink")]
    public string InfoLink { get; set; }

    /// <summary>
    /// Gets or Sets Message
    /// </summary>
    [DataMember(Name="message", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "message")]
    public NotificationMessage Message { get; set; }

    /// <summary>
    /// Gets or Sets Tags
    /// </summary>
    [DataMember(Name="tags", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "tags")]
    public List<int?> Tags { get; set; }

    /// <summary>
    /// Gets or Sets Id
    /// </summary>
    [DataMember(Name="id", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "id")]
    public int? Id { get; set; }


    /// <summary>
    /// Get the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()  {
      var sb = new StringBuilder();
      sb.Append("class Notification {\n");
      sb.Append("  OnGrab: ").Append(OnGrab).Append("\n");
      sb.Append("  OnDownload: ").Append(OnDownload).Append("\n");
      sb.Append("  OnUpgrade: ").Append(OnUpgrade).Append("\n");
      sb.Append("  OnRename: ").Append(OnRename).Append("\n");
      sb.Append("  OnDelete: ").Append(OnDelete).Append("\n");
      sb.Append("  OnHealthIssue: ").Append(OnHealthIssue).Append("\n");
      sb.Append("  SupportsOnGrab: ").Append(SupportsOnGrab).Append("\n");
      sb.Append("  SupportsOnDownload: ").Append(SupportsOnDownload).Append("\n");
      sb.Append("  SupportsOnUpgrade: ").Append(SupportsOnUpgrade).Append("\n");
      sb.Append("  SupportsOnRename: ").Append(SupportsOnRename).Append("\n");
      sb.Append("  SupportsOnDelete: ").Append(SupportsOnDelete).Append("\n");
      sb.Append("  SupportsOnHealthIssue: ").Append(SupportsOnHealthIssue).Append("\n");
      sb.Append("  IncludeHealthWarnings: ").Append(IncludeHealthWarnings).Append("\n");
      sb.Append("  Name: ").Append(Name).Append("\n");
      sb.Append("  Fields: ").Append(Fields).Append("\n");
      sb.Append("  ImplementationName: ").Append(ImplementationName).Append("\n");
      sb.Append("  Implementation: ").Append(Implementation).Append("\n");
      sb.Append("  ConfigContract: ").Append(ConfigContract).Append("\n");
      sb.Append("  InfoLink: ").Append(InfoLink).Append("\n");
      sb.Append("  Message: ").Append(Message).Append("\n");
      sb.Append("  Tags: ").Append(Tags).Append("\n");
      sb.Append("  Id: ").Append(Id).Append("\n");
      sb.Append("}\n");
      return sb.ToString();
    }

    /// <summary>
    /// Get the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson() {
      return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

}
}
