using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace RadarrSharp.Models {

  /// <summary>
  /// 
  /// </summary>
  [DataContract]
  public class QualityProfile {
    /// <summary>
    /// Gets or Sets Name
    /// </summary>
    [DataMember(Name="name", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "name")]
    public string Name { get; set; }

    /// <summary>
    /// Gets or Sets UpgradeAllowed
    /// </summary>
    [DataMember(Name="upgradeAllowed", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "upgradeAllowed")]
    public bool? UpgradeAllowed { get; set; }

    /// <summary>
    /// Gets or Sets Cutoff
    /// </summary>
    [DataMember(Name="cutoff", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "cutoff")]
    public int? Cutoff { get; set; }

    /// <summary>
    /// Gets or Sets Items
    /// </summary>
    [DataMember(Name="items", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "items")]
    public List<Object> Items { get; set; }

    /// <summary>
    /// Gets or Sets MinFormatScore
    /// </summary>
    [DataMember(Name="minFormatScore", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "minFormatScore")]
    public int? MinFormatScore { get; set; }

    /// <summary>
    /// Gets or Sets CutoffFormatScore
    /// </summary>
    [DataMember(Name="cutoffFormatScore", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "cutoffFormatScore")]
    public int? CutoffFormatScore { get; set; }

    /// <summary>
    /// Gets or Sets FormatItems
    /// </summary>
    [DataMember(Name="formatItems", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "formatItems")]
    public List<QualityProfileFormatItems> FormatItems { get; set; }

    /// <summary>
    /// Gets or Sets Language
    /// </summary>
    [DataMember(Name="language", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "language")]
    public QueuedetailsLanguages Language { get; set; }

    /// <summary>
    /// Gets or Sets Id
    /// </summary>
    [DataMember(Name="id", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "id")]
    public int? Id { get; set; }


    /// <summary>
    /// Get the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()  {
      var sb = new StringBuilder();
      sb.Append("class QualityProfile {\n");
      sb.Append("  Name: ").Append(Name).Append("\n");
      sb.Append("  UpgradeAllowed: ").Append(UpgradeAllowed).Append("\n");
      sb.Append("  Cutoff: ").Append(Cutoff).Append("\n");
      sb.Append("  Items: ").Append(Items).Append("\n");
      sb.Append("  MinFormatScore: ").Append(MinFormatScore).Append("\n");
      sb.Append("  CutoffFormatScore: ").Append(CutoffFormatScore).Append("\n");
      sb.Append("  FormatItems: ").Append(FormatItems).Append("\n");
      sb.Append("  Language: ").Append(Language).Append("\n");
      sb.Append("  Id: ").Append(Id).Append("\n");
      sb.Append("}\n");
      return sb.ToString();
    }

    /// <summary>
    /// Get the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson() {
      return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

}
}
