using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace RadarrSharp.Models {

  /// <summary>
  /// 
  /// </summary>
  [DataContract]
  public class TagDetail {
    /// <summary>
    /// Gets or Sets Id
    /// </summary>
    [DataMember(Name="id", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "id")]
    public int? Id { get; set; }

    /// <summary>
    /// Gets or Sets Label
    /// </summary>
    [DataMember(Name="label", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "label")]
    public string Label { get; set; }

    /// <summary>
    /// Gets or Sets DelayProfileIds
    /// </summary>
    [DataMember(Name="delayProfileIds", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "delayProfileIds")]
    public List<int?> DelayProfileIds { get; set; }

    /// <summary>
    /// Gets or Sets NotificationIds
    /// </summary>
    [DataMember(Name="notificationIds", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "notificationIds")]
    public List<int?> NotificationIds { get; set; }

    /// <summary>
    /// Gets or Sets RestrictionIds
    /// </summary>
    [DataMember(Name="restrictionIds", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "restrictionIds")]
    public List<int?> RestrictionIds { get; set; }

    /// <summary>
    /// Gets or Sets NetImportIds
    /// </summary>
    [DataMember(Name="netImportIds", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "netImportIds")]
    public List<int?> NetImportIds { get; set; }

    /// <summary>
    /// Gets or Sets MovieIds
    /// </summary>
    [DataMember(Name="movieIds", EmitDefaultValue=false)]
    [JsonProperty(PropertyName = "movieIds")]
    public List<int?> MovieIds { get; set; }


    /// <summary>
    /// Get the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()  {
      var sb = new StringBuilder();
      sb.Append("class TagDetail {\n");
      sb.Append("  Id: ").Append(Id).Append("\n");
      sb.Append("  Label: ").Append(Label).Append("\n");
      sb.Append("  DelayProfileIds: ").Append(DelayProfileIds).Append("\n");
      sb.Append("  NotificationIds: ").Append(NotificationIds).Append("\n");
      sb.Append("  RestrictionIds: ").Append(RestrictionIds).Append("\n");
      sb.Append("  NetImportIds: ").Append(NetImportIds).Append("\n");
      sb.Append("  MovieIds: ").Append(MovieIds).Append("\n");
      sb.Append("}\n");
      return sb.ToString();
    }

    /// <summary>
    /// Get the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson() {
      return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

}
}
