﻿using RadarrSharp.Services;
using RadarrSharp.Services.Implementation;
using RadarrSharp.Services.Interface;

namespace RadarrSharp
{
    public class RadarrClient
    {
        public IMovieService Movie;
        public IQualityService Quality;
        private string _ip, _port, _apiKey;
        public RadarrClient(string ip, string port, string apiKey)
        {
            this._ip = ip;
            this._port = port;
            this._apiKey = apiKey;
            RegisterRadarrServices();
        }

        private void RegisterRadarrServices()
        {
            Movie = new MovieService(_ip, _port, _apiKey);
            Quality = new QualityService(_ip, _port, _apiKey);
        }
    }
}
